/**************************
	MaxFeedReader
	By Neo101
	Version 1.1.0
**************************/


/********** Settings **********/
// See readme.txt for more info
var NUMBER_OF_CONNECTIONS = 8
var SAVE_RECENT_POSTS = true
var SHOW_AUTHOR = false
var REMOVE_SMALL_IMAGES = true
var USE_CUSTOM_NAMES = false

// if you enable this you can remove advertisement posts from feeds (if they have a special title)
var ENABLE_TITLE_IGNORE = false
var IGNORE_TITLE_REG_EXP = /^ADV: /

/********** End Settings **********/


var SECURITY_ID = max_security_id
var PLUGIN_NAME = 'MaxFeedReader'


window.onload = function(){
	MaxFeedReader.init()
}


var MaxFeedReader = {
	loadedFeeds : 0,
	numberOfFeedsToLoad: 0,
	feedId: 0,
	itemId: 0,
	queue: [],
	loadedFolder: '',
	feedDataObj: {},
	feedTitleObj: {},
	parsedFeedDataObj: {}
}


MaxFeedReader.init = function(){
	MaxFeedReader.setRecentHeadlinesData()
	MaxFeedReader.setFeedDataObj()
	MaxFeedReader.createFeedTree()
}


MaxFeedReader.setFeedDataObj = function(){
	try{
		var rssObj = external.max_getObj(SECURITY_ID, 'rssManager')
	} catch(e){
		alert(',    Maxthon 2.0.1  !\n' + e.description)
		return
	}
	
	if(!rssObj){
		messageLib.setMessage(': rssObj = null', 999)
		// test if SECURITY ID is still valid
		var tab = external.get_tab(SECURITY_ID, external.cur_sel)
		if(!tab){
			$setInnerHtml('feedData', ': ,  Maxthon security_id .    MaxFeedReader.<br />,       ,    .')
		}
	}
	
	var root = rssObj.rootItem
	var rootArray = []
	var result = {}
	
	var children = new Array()
	root.getChildren(children)
	
	for(var i=0; i<children.length; i++){
		var child = children[i]
		if(child.iFolder > 0){ // child is folder or group
			if(! result[child.title] ){
				result[child.title] = []
			}
			MaxFeedReader.getFeedsInFolder(child, result[child.title])
		} else { // child is RSS feed
			MaxFeedReader.feedTitleObj[child.url] = htmlStripLib.stripText(child.title)
			rootArray.push( child )
		}
	}
	result['_root'] = rootArray
	MaxFeedReader.feedDataObj = result
}


MaxFeedReader.getFeedsInFolder = function(parent, array){
	var children = new Array()
	parent.getChildren(children)
	for(var i=0;i<children.length;i++){
		var child = children[i]
		if(child.iFolder > 0){ // child is folder or group
			MaxFeedReader.getFeedsInFolder(child, array)
		} else { // child is RSS feed
			array.push( child )
			MaxFeedReader.feedTitleObj[child.url] = child.title
		}
	}
}


MaxFeedReader.setRecentHeadlinesData = function(){
	try{
		var recentHeadlinesString = MaxLib.readFile('recentHeadlinesData.js')
		if(recentHeadlinesString && recentHeadlinesString != ''){
			eval(recentHeadlinesString)
		} else {
			throw new Error('')
		}
	}catch(e){
		if(e.description != ''){
			alert('   : ' + e.description + '\n    .')
		}
		var recentHeadlinesData = {}
		MaxLib.writeFile('recentHeadlinesData.js', 'var recentHeadlinesData = {}')
	}
	MaxFeedReader.recentHeadlinesData = recentHeadlinesData
}


MaxFeedReader.createFeedTree = function(){
	var html = []
	var feedArray
	for(var folderName in MaxFeedReader.feedDataObj){
		if(folderName != '_root'){
			html.push('<div>')
			html.push('<span onclick="expandCollapse(this.parentElement, true, this)" class="expandCollapse"><img src="images/plus.gif" alt="" /></span>')
			html.push('<span onclick="MaxFeedReader.loadFolder(\'' + folderName + '\', false)" class="folder" title=" ">' + folderName + '</span>')
			html.push('</div>')
		}
		feedArray = MaxFeedReader.feedDataObj[folderName]
		var style = folderName == '_root' ? ' class="rootFolder"' : ' style="display:none"'
		html.push('<ul' + style + '>')
		for(var i=0; i<feedArray.length; i++){
			html.push('<li><a href="' + feedArray[i].url + '" onclick="MaxFeedReader.loadFeed(this.href, false, true); this.blur(); return false">' + htmlStripLib.stripText(feedArray[i].title) + '</a></li>')
		}
		html.push('</ul>')
	}
	if(html.length == 0){
		html = ['<b>:   .</b><br /><br />     Maxthon:   >   > RSS-   .']
	}
	$setInnerHtml('feedList', html.join(''))
}

MaxFeedReader.writeFeedDeamon = function(parsedObj){
	return function(){ MaxFeedReader.writeFeed(parsedObj.feedObj,null, parsedObj.infoObj)}
}


MaxFeedReader.loadFolder = function(folderName, completeFeed){
	$setInnerHtml('errors', '')
	$hide('errors')
	messageLib.clearMessage()
	FeedLib.abortRequests()
	
	if(! folderName in MaxFeedReader.feedDataObj){
		alert(':  ' + folderName + '  !')
		return
	}
	if(MaxFeedReader.loadedFolder != folderName){
		MaxFeedReader.parsedFeedDataObj = {}
	}
	
	MaxFeedReader.setLoadingMessage(folderName)
	
	MaxFeedReader.loadedFeeds = 0
	MaxFeedReader.loadedFolder = folderName
	focusLib.lastSelectedElementId = null
	MaxFeedReader.feedId = 0
	MaxFeedReader.itemId = 0
	
	var feedArray = MaxFeedReader.feedDataObj[folderName]
	MaxFeedReader.numberOfFeedsToLoad = feedArray.length
	
	for(var i=0; i<feedArray.length; i++){
		var url = feedArray[i].url
		if(completeFeed == true && url in MaxFeedReader.parsedFeedDataObj){
			var parsedObj = MaxFeedReader.parsedFeedDataObj[url]
			parsedObj.infoObj.completeFeed = true
			parsedObj.infoObj.storeLatestHeadlines = false
			var writeFunction = MaxFeedReader.writeFeedDeamon(parsedObj)
			if(i < 3){
				var timeout = 300 * i
			} else {
				var timeout = 1000 * i
			}
			window.setTimeout(writeFunction, timeout)
			
		} else {
			var infoObj = {'id': MaxFeedReader.feedId, 'completeFeed' : completeFeed, 
						'storeLatestHeadlines': true, 'url': url}
			if(i < NUMBER_OF_CONNECTIONS){
				FeedLib.loadFeed(url, MaxFeedReader.writeFeed, infoObj)
			} else {
				MaxFeedReader.queue.push([feedArray[i], infoObj])
			}
		}
  		MaxFeedReader.feedId++
	}
	
	if(!completeFeed){
		$setInnerHtml('feedView', '<span onclick="MaxFeedReader.loadFolder(\'' + folderName + '\', true)">  </span>')
	} else {
		$setInnerHtml('feedView', '<span onclick="MaxFeedReader.loadFolder(\'' + folderName + '\', false)">  </span>')
	
	}
}


MaxFeedReader.loadFeed = function(url, completeFeed, storeLatestHeadlines){
	$setInnerHtml('errors', '')
	$hide('errors')
	messageLib.clearMessage()
	FeedLib.abortRequests()
	
	url = unescape(url)

	MaxFeedReader.setLoadingMessage()
	
	MaxFeedReader.loadedFeeds = 0
	MaxFeedReader.numberOfFeedsToLoad = 1
	MaxFeedReader.loadedFolder = ''
	focusLib.lastSelectedElementId = null
	MaxFeedReader.feedId = 0
	MaxFeedReader.itemId = 0
	
	if(completeFeed == true && url in MaxFeedReader.parsedFeedDataObj){
		var parsedObj = MaxFeedReader.parsedFeedDataObj[url]
		parsedObj.infoObj.completeFeed = true
		parsedObj.infoObj.storeLatestHeadlines = false
		MaxFeedReader.writeFeed(parsedObj.feedObj, 
								null, parsedObj.infoObj)
	} else {
		var infoObj = {'id': MaxFeedReader.feedId, 'completeFeed' : completeFeed, 
					'storeLatestHeadlines': storeLatestHeadlines, 'url': url}
		FeedLib.loadFeed(url, MaxFeedReader.writeFeed, infoObj)
		MaxFeedReader.feedId++
	}
	
	if(completeFeed){
		var html = '<span onclick="MaxFeedReader.loadFeed(\'' + escape(url) + '\', false, true)">'+
					'  '+
				'</span>'
	} else {
		var html = '<span onclick="MaxFeedReader.loadFeed(\'' + escape(url) + '\', true, true)">'+
					'  '+
				'</span>'
	}
	$setInnerHtml('feedView', html)
}


MaxFeedReader.writeFeed = function(feedObj, error, infoObj){
	var html = []
	MaxFeedReader.loadedFeeds += 1
	if(!error){
		MaxFeedReader.parsedFeedDataObj[infoObj.url] = {'feedObj' : feedObj, 'infoObj': infoObj}
	}
	
	if( MaxFeedReader.loadedFeeds == MaxFeedReader.numberOfFeedsToLoad ){
		$setInnerHtml('status', '') //Loading completed
		$hide('loading')
	} else {
		if($id('percentage')){
			$setInnerHtml('percentage', 
					Math.round( MaxFeedReader.loadedFeeds / MaxFeedReader.numberOfFeedsToLoad * 100) + '%')
		}
	}
	
	if(feedObj == null){
		$show('errors')
		var name = MaxFeedReader.feedTitleObj[infoObj.url] || infoObj.url 
		$id('errors').innerHTML += '  <a href="' + infoObj.url + '" target="_blank">' + 
										name + '</a>: ' + error + '<br />'
		MaxFeedReader.loadFromQueue()
		return
	}
	
	var feedName = USE_CUSTOM_NAMES ? MaxFeedReader.feedTitleObj[infoObj.url] : feedObj.title
	html.push( '<h2 id="' + infoObj.id + '">' +
				'<a href="' + feedObj.homepageUrl + '" target="_blank">' +
					feedName +
				'</a>'+
			  '</h2>' )
	
	var hasNewItems = false
	var escapedUrl = escape(feedObj.url)
	
    //var startTime = new Date().getTime()
	for(var i=0; i<feedObj.nodes.length; i++){
		var item = feedObj.nodes[i]
		if(SAVE_RECENT_POSTS && !infoObj.completeFeed && 
					escapedUrl in MaxFeedReader.recentHeadlinesData && 
					escape(item.title) in MaxFeedReader.recentHeadlinesData[escapedUrl]){
			break
		}
		hasNewItems = true
		item = FeedLib.stripFeedItem(item, feedObj.homepageDomain)
		html.push('<div class="item">')
		html.push('<h3 id="item_' + MaxFeedReader.itemId + '">')
		if(item.link){
			html.push( '<a href="' + item.link + '" target="_blank">' + item.title + '</a>')
		} else {
			html.push( item.title )
		}
		html.push('</h3>')
		var metaInfo = item.date ? ': ' + MaxFeedReader.returnDate(item.date) : ''
		metaInfo += SHOW_AUTHOR && item.author ? ' : ' + item.author : ''
		
		html.push('<div class="item-text">' + item.text + '</div>')
		if(metaInfo != ''){
			html.push('<div class="item-details">' + metaInfo + '</div>')
		}
		html.push('</div>')
		
		MaxFeedReader.itemId++
	}
    //var endTime = new Date().getTime()
    //alert(endTime - startTime)

	if(hasNewItems){
		var dataElement = document.createElement('div')
		dataElement.innerHTML = ( html.join(''))
		$id('feedData').appendChild(dataElement) 
		$hide('loading')
	}
	else if((MaxFeedReader.numberOfFeedsToLoad == 1 || MaxFeedReader.loadedFeeds == MaxFeedReader.numberOfFeedsToLoad) && $id('feedData').innerHTML == ''){
		if(infoObj.completeFeed == true){
			$setInnerHtml('feedData', '<div> ,    !</div>')
		} else {
			$setInnerHtml('feedData', '<div> ,   !</div>')
		}
	}
	
	MaxFeedReader.loadFromQueue()
	
	if(SAVE_RECENT_POSTS && infoObj.storeLatestHeadlines && hasNewItems){
		MaxFeedReader.recentHeadlinesData[escapedUrl] = {}
		for(var i=0; i<feedObj.nodes.length && i<3; i++){
			MaxFeedReader.recentHeadlinesData[escapedUrl][ escape(feedObj.nodes[i].title) ] = true
		}
		
		MaxLib.writeFile('recentHeadlinesData.js', 
					'var recentHeadlinesData = '+JSON.objectToJSON( MaxFeedReader.recentHeadlinesData ))
	}
}



MaxFeedReader.loadFromQueue = function(){
	if(MaxFeedReader.queue.length > 0){
		var feed = MaxFeedReader.queue.pop()
		if(MaxFeedReader.itemId < 10){
			var timeout = 100
		} else if(MaxFeedReader.itemId > 100){
			var timeout = 3000
		} else {
			var timeout = 1000
		}
		window.setTimeout(function(){
				FeedLib.loadFeed(feed[0].url, MaxFeedReader.writeFeed, feed[1])
		}, timeout)
	}
}



MaxFeedReader.returnDate = function(date){
	try{
		return date.toLocaleString()
	} catch(e){
		return '  ' + date
	}
}


MaxFeedReader.setLoadingMessage = function(name){
	if(!name){
		name = ''
	}
	$setInnerHtml('feedData','')
	$show('loading')
	$setInnerHtml('status', ' ' + name + '... (<span id="percentage">0%</span>)')
}



